#made by SpielmitStil
#heavily modified by TheRedstoneer
#multiplayer compatible with unique IDs

effect give @a minecraft:saturation 99999 100 true
effect give @a minecraft:resistance 99999 100 true
recipe take @a *
gamemode adventure @a[gamemode=survival]

execute if entity @a[tag=!setup] run function raycast:setup

#predefine
execute as @e[tag=red_main] store result score @s ID run execute if entity @a
scoreboard players set @e[tag=ray] rayspeed 100

clear @a[nbt=!{Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:0b}]}] minecraft:carrot_on_a_stick
replaceitem entity @a[nbt=!{Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:0b}]}] hotbar.0 minecraft:carrot_on_a_stick{display:{Name:"{\"text\":\"Ray Gun\",\"color\":\"dark_purple\",\"italic\":false}",Lore:["§r§7Right click to shoot a laser","§r§7that interacts with specific blocks"]},HideFlags:63,Unbreakable:1b} 1

#Create Raycast Entities
execute as @a[scores={raycast=1..}] at @s anchored eyes run summon area_effect_cloud ^ ^ ^1 {Duration:5,NoGravity:1,Tags:["ray","notsetup"]}
execute as @e[tag=ray,tag=notsetup] at @s rotated as @a[scores={raycast=1..}] run tp @s ~ ~ ~ ~ ~
scoreboard players operation @e[tag=ray,tag=notsetup] ID = @a[scores={raycast=1..}] ID
tag @e[tag=ray,tag=notsetup] remove notsetup

execute as @e[tag=ray] at @s run function raycast:ray
scoreboard players reset @a[scores={raycast=1..}] raycast

#mechanics
execute as @e[tag=global] run function raycast:bossbar
execute as @e[type=area_effect_cloud,name=block] at @s run function raycast:blocks
execute as @e[type=area_effect_cloud,name=lwall] at @s run function raycast:lwall
execute as @a at @s if block ~ ~-1 ~ gold_block run function raycast:checkpoint/set
function raycast:effectblocks
function raycast:particles
execute as @e[tag=cp] at @s run function raycast:checkpoint/particle
function raycast:secret

execute as @e[type=armor_stand,name=activator,tag=y] at @s run execute as @a[distance=..2] run scoreboard players set @e[type=area_effect_cloud,name=ablock,tag=y] timer 10
execute as @e[type=armor_stand,name=activator,tag=b] at @s run execute as @a[distance=..2] run scoreboard players set @e[type=area_effect_cloud,name=ablock,tag=b] timer 10
execute as @e[type=armor_stand,name=activator,tag=g] at @s run execute as @a[distance=..2] run scoreboard players set @e[type=area_effect_cloud,name=ablock,tag=g] timer 10
execute as @e[type=armor_stand,name=activator,tag=r] at @s run execute as @a[distance=..2] run scoreboard players set @e[type=area_effect_cloud,name=ablock,tag=r] timer 10
execute as @e[type=area_effect_cloud,name=ablock,scores={timer=1..}] at @s run function raycast:activators

#checkpoint
execute as @a[y=0,gamemode=adventure] at @s positioned ~ 0 ~ if entity @s[dy=26] run function raycast:checkpoint/goto



#create nessesary Entities if not there
execute unless entity @e[type=area_effect_cloud,tag=cp] run function raycast:checkpoint/create



kill @e[type=item]
